
--[[     URLCopy Module     ]]--

local _, BCM = ...
BCM.modules[#BCM.modules+1] = function()
	if bcmDB.BCM_URLCopy then return end

	local repTbl = {
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?/%S+",
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.[%a%-%d]+%.%a%a%a?/%S+",
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?/",
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.[%a%-%d]+%.%a%a%a?/",
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?$",
		"%a-://[%a%-%d]*%.?[%a%-%d]+%.[%a%-%d]+%.%a%a%a?$",
		"(%a-://[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?) ",
		"(%a-://[%a%-%d]*%.?[%a%-%d]+%.[%a%-%d]+%.%a%a%a?) ",
		"[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?/%S+",
		"[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?/",
		"[%a%-%d]*%.?[%a%-%d]+%.%a%a%a?$",
		"([%a%-%d]*%.?[%a%-%d]+%.%a%a%a?) ",
		"%d+%.%d+%.%d+%.%d+:?%d*/?%S*",
	}

	local gsub = gsub
	local filterFunc = function(_, _, msg, ...)
		for i=1, #repTbl do
			local newMsg, found = gsub(msg, repTbl[i], "|cffffffff|Hbcmurl~%1|h[%1]|h|r")
			if found > 0 then return false, newMsg, ... end
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT_LEADER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_CONVERSATION", filterFunc)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_INLINE_TOAST_BROADCAST", filterFunc)

	local SetHyperlink = ItemRefTooltip.SetHyperlink
	function ItemRefTooltip:SetHyperlink(data, ...)
		local isURL, link = strsplit("~", data)
		if isURL and isURL == "bcmurl" then
			BCM:Popup(link)
		else
			SetHyperlink(self, data, ...)
		end
	end
end

